=== thirdparty/msvc/Makefile ===
update: \
	inttypes.h \
	stdint.h

%.h: FORCE
	wget -N http://msinttypes.googlecode.com/svn/trunk/$@

.PHONY: update

FORCE:
