=== debian/changelog ===
apitrace (3.0+git20121018.d1c301f7-0ubuntu1) raring; urgency=low

  * Initial release (Closes: #636679, LP: #813848)

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Mon, 13 Feb 2012 16:32:44 +1100
