=== debian/control ===
Source: apitrace
Section: graphics
Priority: optional
Maintainer: Christopher James Halse Rogers <raof@ubuntu.com>
Build-Depends:
 debhelper (>= 9),
 cmake,
 libgl1-mesa-dev,
 libegl1-mesa-dev,
 libgles1-mesa-dev,
 libgles2-mesa-dev,
 libqt4-dev,
 libqtwebkit-dev,
 libqjson-dev,
 libsnappy-dev,
 libpng12-dev,
 pkg-config,
 python,
 zlib1g-dev,
Standards-Version: 3.9.3
Homepage: https://github.com/apitrace/apitrace
Vcs-Git: git://git.debian.org/pkg-xorg/app/apitrace.git
Vcs-Browser: http://git.debian.org/?p=pkg-xorg/app/apitrace.git;a=summary

Package: apitrace-gl-frontend
Architecture: any
Depends: 
 ${shlibs:Depends},
 ${misc:Depends},
 apitrace-gl-tracers (= ${binary:Version}),
 python,
 python-imaging,
Description: tools for debugging OpenGL applications and drivers - tracing frontends
 apitrace is a suite of tools for debugging OpenGL applications and drivers.
 It includes a tool to generate a trace of all the OpenGL calls an applicaton
 makes and a tool for replaying these traces and inspecting the rendering and
 OpenGL state during the program's execution.
 .
 This makes it useful for identifying the sources of graphical corruption in
 OpenGL applications.
 .
 This package contains frontends for the apitrace tool, making it easy to trace
 applicatons and replay, compare, profile, and modify existing traces.

Package: apitrace-gl-tracers
Architecture: any
Depends: 
 ${shlibs:Depends},
 ${misc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: tools for debugging OpenGL applications and drivers - application tracer
 apitrace is a suite of tools for debugging OpenGL applications and drivers.
 It includes a tool to generate a trace of all the OpenGL calls an applicaton
 makes and a tool for replaying these traces and inspecting the rendering and
 OpenGL state during the program's execution.
 .
 This makes it useful for identifying the sources of graphical corruption in
 OpenGL applications.
 .
 This package contains the components required to trace the OpenGL calls made
 by an application and record them into a trace file for later replay and
 debugging.
