=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_EGL=YES -DENABLE_GUI=YES

override_dh_install:
	# Remove some files we don't want, then fail if there's anything left
	-rm debian/tmp/usr/share/doc/apitrace/LICENSE
	dh_install --fail-missing

override_dh_clean:
        # The buildsystem doesn't clean the generate python bytecode
	find . -name *.pyc -delete
	dh_clean

%:
	dh $@ --parallel
