=== debian/watch ===
version=3
opts=filenamemangle=s/\/apitrace\/apitrace\/tarball\/(.*)/apitrace-$1\.tar\.gz/ \
    https://github.com/apitrace/apitrace/downloads /apitrace/apitrace/tarball/(.*)
